
/**
 * File Name: Main.js (OLOO)
 * Live Demo: https://makingbrowsergames.com/starterkits/<directory>
 * Source Code: https://makingbrowsergames.com/starterkits/
 * Description: File for controlling and displaying game scenes; managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 0.0.0.xxx
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright © 1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *   and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use; 
 *   doing so will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 */

"use strict";
/** game set-up **/
console.log ("%c %c %c|   Starting my awesome v2.x.x game Prototype!     |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
console.log ("%c %c %c|    Phaser v2 Game Prototyping Starter Kit        |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
console.log ("%c %c %c|     Copyright \u00A9 1974-2017, Stephen Gose.         |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
console.log ("%c %c %c| \u2665\u2665\u2665\u2665\u2665 -> https://renown-games.com/shop/                |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
console.log ("%c %c %c| \u2665\u2665\u2665\u2665\u2665 -> $120 License included in book!          |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
console.log ("%c %c %c| Book available at: https://leanpub.com/LoRD       |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
//creates an object namespace
 function gameMechanics(){
		
	console.log("%c %c %c|              Game mechanics launched             |%c %c ","background: #00bff3","background: #0072bc","color: #ffffff; background: #003471","background: #0072bc","background: #00bff3");
	
 };
 
window.GAMEAPP = {
	
	// reference to the Phaser.Game instance
	game: null,
	
	//US Copr. or Copyright
	Copr: "Copyright © 2007-2017, Stephen Gose. All rights reserved.\n",


	//assign a unique game code for local storage
	gDefDelim: "game SKU",	//See cookie/local.storage below
	
	//Canvas dimensions: world and viewports' Height and Width
	//**TODO** adjust for your game deployment
	viewportWidth:	800,	//game view using Golden Ration
	viewportHeight:	500,
	worldWidth:		800,	//world view using Golden Ration
	worldHeight:	500,
	
	//==================================================
	//**TODO** refactor and adjust for your own game deployment
	//	Trash Global Variables (alphabetical)
	//	Here we have some global level vars that persist regardless of State. 
	//==================================================
	gameLanguage: 0,	//Default is English (American)
	
	//button styling
	styleBTN: { font: "26px Arial", fill: "#000000", align: "center" },
	//Combat HUD styling
	//	hero text
	styleCmbtH: { font: "9px Arial", fill: "#66ffff", align: "center" },	
	styleNarrH: { font: "9px Arial", fill: "#66ffff", align: "left" },
	//	monster text
	styleCmbtM: { font: "9px Arial", fill: "#66ff66", align: "center" },
	styleNarrM: { font: "9px Arial", fill: "#66ff66", align: "left" },
	//HUD styling
	styleHUD: { font: "14px Arial", fill: "#ff9900", align: "center" },
	//Room Alert styling
	styleRA: { font: "18px Arial", fill: "#ff9900", align: "center" },
	//Dynamic Story style
	styleStory: { font: "16px Arial", fill: "#ff9900", align: "left" },
	//toolTip styling
	styleTT: { font: "11px Arial", fill: "#ff9900", align: "center" },
	
	// main function
	main: function(){
		this.game = new Phaser.Game(
			this.viewportWidth, 
			this.viewportHeight, 
			Phaser.AUTO, 
			document.body, 
			window.GAMEAPP.state.boot);
	},
	
	// Game Mechanics (Attributes, Objects & Roses);
	//   here we will store all game phase/states
	//   state object filled as js files load.
	state: {},
	
	// =================================================
	// -------------------------------------------
	// Supporting game Function & Classes
	// -------------------------------------------
	//**TODO**:
	//	Change namespace from generic GAMEAPP to your project 
	//	refactor and adjust for your game deployment
	//	remove console debug information on public deployment
	// =================================================
	// 
	// =================================================
	_assignLanguage: function(){
		//This could be loaded externally from a JSON file
		//I choose to have this internal to avoid additional downloads.
		//  If loading a file from outside of the domain in which the game is running 
		//  a 'Access-Control-Allow-Origin' header must be present on the server.
		switch(GAMEAPP.gameLanguage){
			case 0:	//"english":
				console.log("English selected");
				GAMEAPP.credittxt= "Credits & Info";
				GAMEAPP.donatxt= "Support Us";
				GAMEAPP.helptxt= "Help & Instructions";
				GAMEAPP.introPara= "Introduction game-text here.\n";
				GAMEAPP.moretxt= "More games";
				GAMEAPP.opttxt= "Options";
				GAMEAPP.playtxt= "Start Game";
				GAMEAPP.sharetxt= "Share with friends";
				GAMEAPP.webtxt= "Webmaster License Info";
				break;
			
			case 1: //"china"
				GAMEAPP.credittxt = "片尾";
				GAMEAPP.donatxt = "";
				GAMEAPP.helptxt = "游戏说明";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "更多的游戏";
				GAMEAPP.opttxt = "游戏选项";
				GAMEAPP.playtxt = "玩这个游戏";
				GAMEAPP.sharetxt = "分享此游戏";
				GAMEAPP.webtxt =  "";
				break;
			
			case 2:	//"denmark":
				GAMEAPP.credittxt = "afsluttende credits";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "spil instruktioner";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "flere spil";
				GAMEAPP.opttxt = "spilindstillinger";
				GAMEAPP.playtxt = "spille dette spil";
				GAMEAPP.sharetxt = "deler dette spil";
				GAMEAPP.webtxt =  "";	
				break;
			
			case 3:	//"french":
				GAMEAPP.credittxt = "générique de fin";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Instructions du jeu";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "plus de jeux de";
				GAMEAPP.opttxt = "options de jeu";
				GAMEAPP.playtxt = "Jouer à ce jeu";
				GAMEAPP.sharetxt = "partager ce jeu";
				GAMEAPP.webtxt =  "";
				break;

			case 4:	//"german":
				GAMEAPP.credittxt = "Abspann";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Anweisungen";
				GAMEAPP.introPara =""; 
				GAMEAPP.moretxt = "mehr";
				GAMEAPP.opttxt = "Spieloptionen";
				GAMEAPP.playtxt = "Spiel";
				GAMEAPP.sharetxt = "Aktien dieser";
				GAMEAPP.webtxt =  "";
				break;	
				
			case 5:	//"italian":
				GAMEAPP.credittxt = "Associare";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Istruzioni di gioco";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "Quantità";
				GAMEAPP.opttxt = "Opzioni del gioco";
				GAMEAPP.playtxt = "Giocare questo gioco";
				GAMEAPP.sharetxt = "Condividere questo gioco";
				GAMEAPP.webtxt =  "";
				break;
			
			case 6:	//"japanese":
				GAMEAPP.credittxt = "閉じるクレジット";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "ゲームの説明";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "より多くのゲーム";
				GAMEAPP.opttxt = "ゲームオプション";
				GAMEAPP.playtxt = "このゲームをプレイ";
				GAMEAPP.sharetxt = "共有このゲーム";
				GAMEAPP.webtxt =  "";
				break;
			
			case 7:	//"netherlands":
				GAMEAPP.credittxt = "Credits";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Spelregels";
				GAMEAPP.introPara =  "";
				GAMEAPP.moretxt = "meer games";
				GAMEAPP.opttxt = "spelopties";
				GAMEAPP.playtxt = "dit spel";
				GAMEAPP.sharetxt = "aandeel dit spel";
				GAMEAPP.webtxt =  "";
				break;
			
			case 8:	//"portugal":
				GAMEAPP.credittxt = "créditos finais";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Instruções de jogo";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "mais jogos";
				GAMEAPP.opttxt = "opções de jogo";
				GAMEAPP.playtxt = "Jogar este jogo";
				GAMEAPP.sharetxt = "Compartilhe este jogo";
				GAMEAPP.webtxt =  "";
				break;
			
			case 9:	//"spain":
				GAMEAPP.credittxt = "Créditos";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "Instrucciones";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "Más";
				GAMEAPP.opttxt = "Opciones de juego";
				GAMEAPP.playtxt = "Jugar a este juego";
				GAMEAPP.sharetxt = "Compartir esta";
				GAMEAPP.webtxt = "";		
				break;
			
			case 10:	//"sweden":
				GAMEAPP.credittxt = "eftertexterna";
				GAMEAPP.donatxt =  "";
				GAMEAPP.helptxt = "instruktioner";
				GAMEAPP.introPara = "";
				GAMEAPP.moretxt = "mer";
				GAMEAPP.opttxt = "Spelalternativ";
				GAMEAPP.playtxt = "Spela";
				GAMEAPP.sharetxt = "VARA DELAKTIG I";
				GAMEAPP.webtxt =  "";
				break;
			
			default:
				console.log("English selected");
				GAMEAPP.credittxt= "Credits & Info";
				GAMEAPP.donatxt= "Support Us";
				GAMEAPP.helptxt= "Help & Instructions";
				GAMEAPP.introPara= "";
				GAMEAPP.moretxt= "More games";
				GAMEAPP.opttxt= "Options";
				GAMEAPP.playtxt= "Start Game";
				GAMEAPP.sharetxt= "Share with friends";
				GAMEAPP.webtxt= "Webmaster License Info";
				
				break;
		}
	},	

	// 
	// =================================================
	// -------------------------------------------
	// End Main game Handler
	// -------------------------------------------
	// =================================================

	/**
	//TODO: v2.x.x label integration
	_labelButton: function(game,x,y,key,label,callback,  
		callbackContext, overFrame, outFrame, downFrame, upFrame){
		Phaser.Button.call(this,game,x,y,key,callback,  
		callbackContext, overFrame, outFrame, downFrame, upFrame);  
		//Style how you wish...    
		this.style = {'font': '10px Arial','fill':'black'};  
		this.anchor.setTo( 0.5, 0.5 );  
		this.label = new Phaser.Text(game, 0, 0, label, this.style);  
		//puts the label in the center of the button  
		this.label.anchor.setTo( 0.5, 0.5 );  
		this.addChild(this.label);  
		this.setLabel( label );  
		//adds button to game  
		game.add.existing( this );  	
	}
	_labelButton.prototype = Object.create(Phaser.Button.prototype);  
	_labelButton.prototype.constructor = _labelButton;  
	_labelButton.prototype.setLabel = function( label ) {  
		this.label.setText(label);  
	}

	*/	
};
console.log("Game obj: === Ext? "+Object.isExtensible( GAMEAPP ));
//console.log(Object.values(GAMEAPP));
//console.log(Object.getPrototypeOf(GAMEAPP));
console.log(Object.getOwnPropertyDescriptors(GAMEAPP));

/** DEPRECATED METHOD - NEVER EVER USE THIS AGAIN!
* 	See Phaser.js Game Design Workbook for complete explanation
*	https://leanpub.com/phaserjsgamedesignworkbook
* 	window.onload = function () {
*	    let game = new Phaser.Game(0, 0, Phaser.AUTO, document.body);
*	};
*/

//preferred launch method for BOM.
document.addEventListener('DOMContentLoaded', function(){
	window.GAMEAPP.main();
}, false);

console.log("Phaser.Game obj: === Ext? "+Object.isExtensible( Phaser.Game ));
//console.log(Object.values(Phaser));
//console.log(Object.getPrototypeOf(Phaser));
console.log(Object.getOwnPropertyDescriptors(Phaser));
 