/**
 * File Name: exit.js
 * File URL:<_ _>
 * Description: File for controlling game exit and gargabe collection.
 * Author: Stephen Gose
 * Version: 0.0.0.xxxx semver launch date
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *   and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use 
 *   and will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 */
	"use strict";
	window.GAMEAPP.state.exitGame = {
		preload: function(){
			console.log("loading Exit Game state");
			GAMEAPP.CrntRoom = GAMEAPP.Logout;
			this.game.load.image('exitGame', 'assets/images/staticScenes/exitGame.jpg');
			this.load.spritesheet('button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30);
			this.load.spritesheet('Death','assets/spriteSheets/ARRADeath/ARRADeath.png',160,100);
			this.load.atlas('inventoryButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
			this.load.atlas('exitButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
			this.load.atlas('saveButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
			this.load.atlas('shareButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
			this.load.atlas('submitButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
		},
		
		create: function(){
			console.log("starting Exit Game state");
			this.game.add.image(0, 0, 'exitGame');
			// Game Mechanics (Space & Area of Interest): camera;
			//   Set a neutral background color
			this.game.stage.backgroundColor = "#000";
			
			//ARRA Character Death animation
			this.ARRADeath = this.game.add.sprite(372, 212, 'Death');
	
			//  Here we add a new animation called 'show Death'
			//  Because we didn't give any other parameters it's going to make an animation from all available frames in the ARRA Death sprite sheet
			var showDeath = this.ARRADeath.animations.add('showDeath');
	
			//  And this starts the animation playing by using its key ("showDeath")
			//  30 is the frame rate (30fps)
			//  true means it will loop when it finishes
			this.ARRADeath.animations.play('showDeath', 8, true);
			
			// =================================================
			// Game Mechanics (Attributes, Objects & Roses);
			//   navigate to selected state
			// =================================================
			this.inventorytxt = this.game.add.text(0, 0, "Inventory" , GAMEAPP.styleBTN);
			this.exittxt = this.game.add.text(0, 0, "Exit" , GAMEAPP.styleBTN);	
			this.submitScore = this.game.add.text(0, 0, "Submit" , GAMEAPP.styleBTN);
			this.save = this.game.add.text(0, 0, "Save" , GAMEAPP.styleBTN);
			this.newGame = this.game.add.text(0, 0, "New Game?" , GAMEAPP.styleBTN);
			this.newGame.events.onInputDown.add(this._NewGame, this);
			this.share = this.game.add.text(0, 0, "Share" , GAMEAPP.styleBTN);
			
			// Inventory button 
			this.inventoryButton = this.game.add.button(65, 338, 'button', this._Inventory, this, 2, 1, 0,1);
			this.inventoryButton.anchor.set(0.5,0.5);
			this.inventoryButton.scale.setTo(0.5,0.5);
			this.inventoryButton.addChild(this.inventorytxt).anchor.set(0.5,0.5);
			
			// Exit button 
			this.exitButton = this.game.add.button(65, 361, 'button', GAMEAPP._ExitGame, this, 2, 1, 0,1);
			this.exitButton.anchor.set(0.5,0.5);
			this.exitButton.scale.setTo(0.5,0.5);
			this.exitButton.addChild(this.exittxt).anchor.set(0.5,0.5);
			
			// New Game button 
			this.shareButton = this.game.add.button(240, 338, 'button', GAMEAPP._newGame, this, 2, 1, 0,1);
			this.shareButton.anchor.set(0.5,0.5);
			this.shareButton.scale.setTo(0.5,0.5);
			this.shareButton.addChild(this.newGame).anchor.set(0.5,0.5);
			
			// Submit button 
			this.submitButton = this.game.add.button(152, 338, 'button', this._SubmitRoom, this, 2, 1, 0,1);
			this.submitButton.anchor.set(0.5,0.5);
			this.submitButton.scale.setTo(0.5,0.5);
			this.submitButton.addChild(this.submitScore).anchor.set(0.5,0.5);
			
			// Save button 
			this.saveButton = this.game.add.button(152, 361, 'button', this._SaveRoom, this, 2, 1, 0,1);
			this.saveButton.anchor.set(0.5,0.5);
			this.saveButton.scale.setTo(0.5,0.5);
			this.saveButton.addChild(this.save).anchor.set(0.5,0.5);
			
			// Share button 
			this.shareButton = this.game.add.button(240, 361, 'button', this._ShareRoom, this, 2, 1, 0,1);
			this.shareButton.anchor.set(0.5,0.5);
			this.shareButton.scale.setTo(0.5,0.5);
			this.shareButton.addChild(this.share).anchor.set(0.5,0.5);
			
			this._toolTip = this.game.add.text(this.game.world.width-100, this.game.world.height-90, GAMEAPP.InfoText, GAMEAPP.styleTT);
			this._toolTip.anchor.set(0.5);
			GAMEAPP.InfoText = "Experience & Score: "+String(CCP.Score)+"\n Renown Earned: "+String(CCP.Renown);
			GAMEAPP.RoomAlert = "Quest failed!";
			//rv_5
			//Send update to server as a "heart beat / keep alive"
			//TXBuffer();
			//Heart.send("update.asp",POST);
/**			
			//rv_8
			//IBPrpArcade game scores enabled
			var gname="ARRA-PBMCube";
			var pname = CCP.Name;
			var gscore = CCP.Renown;
			//getURL("index.php?act=Arcade&do=newscore", "_blank", "POST");
*/			
		},
		
		update: function(){
			this._toolTip.setText(GAMEAPP.InfoText);
			
			//this.ARRADeath.x = this.game.world.width-178;
			//this.ARRADeath.y = 212;
			this.ARRADeath.animations.play('showDeath', 8, true);
		},
		

	};
	
//
// =================================================
/* End of file */
/* Location: ./js/state/exitGame.js */