/**
 * File Name: story.js
 * File URL:<_ _>
 * Description: File for controlling initial entry into game shell and scenes; managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 0.0.0.xxxx semver launch date
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *   and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use 
 *   and will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 * This file is automatically loaded from state/load.js
 * to change default state - change state/load.js at line: 34
 */

 "use strict";

// 
// =================================================
//ARNCCP: NCC Padora story generator
var plotType = [	
    "Your story is ...",
    "Your tale begins this way ...",
    "Here's how your new Quest begins ...",
    "Here's what happened ...",
    "Once upon a time in a galaxy far far away ..."

	];

// 
// =================================================
var authorityFigure = [
    "You are brilliant, yet infamous, rogue merchant smuggler escaping the local star system within the",  
    "You are a Space Marine warrior transferring to a new duty station in the",  
    "You are a quality assurance scientist assigned to monitor the",  
    "You are a cargo merchant travelling to the",  
    "You are an engineering student transferring to the University in the",  
    "You are a pious and powerful cleric on an inquisition mission to the",
    "You are a powerful legendary Jedi sensing something unusal in the",  
    "You are a rich consultant seeking to advise business in the",  
    "Your are a chancellor/advisor of the local lord on assignment to the",  
    "You are the head of the local adventurer's guild auditing chapters based in the", 
    "You are the local captain of the guard on escort duty to the",   
];  

// 
// =================================================
var greekNames = [
	"Acantha",
	"Achilles",
	"Adonis",
	"Adrastea",
	"Adrastos",
	"Aegle",
	"Aella",
	"Agaue",
	"Aiolos",
	"Alekto",
	"Althea",
	"Cassandra",
	"Castor",
	"Chloe",
	"Damon",
	"Daphne",
	"Dardanos",
	"Epimetheus",
	"Europa",
	"Nemesis",
	"Oedipus",
	"Pegasus"

];

// 
// =================================================
var greekLetters = [	
    "Alpha",  
    "Beta",  
    "Gamma",
	"Delta",
	"Epsilon",
	"Zeta",
	"Eta",
	"Theta",
	"Iota",
	"Kappa",
	"Lambda",
	"Mu",
	"Nu",
	"Xi",
	"Omicron",
	"Pi",
	"Rho",
	"Sigma",
	"Tau",
	"Upsilon",
	"Phi",
	"Chi",
	"Psi",
	"Omega",
    
];

// 
// =================================================
window.GAMEAPP.state.story = {
	preload: function(){
		console.log(" %c <SKU> rv_xxx Story & Main Menu Game Prototype", "color:white; background:red");
		//GAMEAPP.InfoText = "Main Menu Selections";
		
		//<SKU> mainMenu & Story collapse into one scene
		this.load.spritesheet('button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30);
		//GAMEAPP._assignLanguage(GAMEAPP.gameLanguage);
		//using altas for graphics; loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		//this._preloadResources();
	},
	
	create: function(){
		console.log("starting story line state");
		var style = {};
		
		if (GAMEAPP.gameLanguage == 0) {
			this.game.add.image(0, 0, 'storyScene');
			style = { font: "12px Arial", fill: "#F90", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 245 };
			this.introParatxt = this.add.text(1000,0, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			//this.introParatxt.setTextBounds(555, 70, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}else{
			this.game.add.image(0, 0, 'storyScene');
			// the alignment of the text is independent of the bounds, try changing to 'center' or 'right'
			style = { font: "14px Arial", fill: "#FFF", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 230 };
			this.introParatxt = this.add.text(0,0, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			this.introParatxt.setTextBounds(550, 138, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}
		
		//displayCanvas0();
		var Legend = "";
		var format = Math.floor(Math.random()*plotType.length);;  
		var authfig = Math.floor(Math.random()*authorityFigure.length); 
		var destination = Math.floor(Math.random()*greekLetters.length); 
		var transit = Math.floor(Math.random()*greekLetters.length);
		var star = Math.floor(Math.random()*greekLetters.length);	
		var computer = Math.floor(Math.random()*greekNames.length); 
	
	
	console.log("Story Generation");  //debug
	console.log("     "+plotType[format]+" "+authorityFigure[authfig]+" "+greekLetters[destination]+" quadrant. You have secured a government seating on the NCC Pandora ( a scientific research vessel ). Its final destination is the "+greekLetters[transit]+" quadrant; fortunately, it must pass through the "+greekLetters[destination]+" quadrant. \n\n Unknown to you is the NCC Pandora had recently upgraded their navigation system and ship computers on their "+greekNames[destination]+"-"+greekLetters[destination]+"-"+Math.floor(Math.random()*6)+" operating system. Due to a small minut computational error, the NCC Pandora crossed dangerously close to the "+greekLetters[star]+"-"+Math.floor(Math.random()*16)+" star which dirupted all the vessel's computer systems. \n\n You awake from stasis to learn of the ship-wide system shutdown in 30 minutes. Your goal is to find all six ship's computers, manually defrag their memory content sufficiently to survive a full system reboot on each system.");  //debug
		var str = "     "+plotType[format]+" "+authorityFigure[authfig]+" "+greekLetters[destination]+" quadrant. You have secured a government seating on the NCC Pandora ( a scientific research vessel ). Its final destination is the "+greekLetters[transit]+" quadrant; fortunately, it must pass through the "+greekLetters[destination]+" quadrant. \n     Unknown to you is the NCC Pandora had recently upgraded their navigation system and ship computers on their "+greekNames[destination]+"-"+greekLetters[destination]+"-"+Math.floor(Math.random()*6)+" operating system. Due to a small minut computational error, the NCC Pandora crossed dangerously close to the "+greekLetters[star]+"-"+Math.floor(Math.random()*16)+" star which disrupted all the vessel's computer systems. \n     You awake from stasis to learn of the ship-wide system shutdown in 30 minutes. Your goal is to find all six ship's computers, manually defrag their memory content sufficiently to survive a full system reboot on each system. \n";
		 
		
		//Goto main menu
		var buttonContinue = this.game.add.button(this.world.width, this.world.centerY+50, 'button-continue', this.clickContinue, this, 1, 0, 2,0);
		
		buttonContinue.anchor.set(1,1);
		buttonContinue.x = this.world.width+buttonContinue.width+20;
		
		this.add.tween(buttonContinue).to({x: this.world.width-20}, 500, Phaser.Easing.Exponential.Out, true);

		this._toolTip = this.game.add.text(20, this.world.centerY-140, "The Story thus far ... \n"+str, GAMEAPP.styleStory);
		this._toolTip.wordWrap = true;
		this._toolTip.wordWrapWidth =630;
		this._toolTip.anchor.set(0,0);
		this._toolTip.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		this._toolTip.fontWeight = 'bold';
		// Game Mechanics (Space & Area of Interest): camera;
		this.camera.flash(0x000000, 500, false);
		
	},
	
	update: function(){
		
	},
	
	//
	// =================================================
	clickContinue: function() {
		//GAMEAPP._playAudio('click');
		this.camera.fade(0x000000, 200, false);
		this.time.events.add(200, function() {
			//BBS & Flash website: TIGStart method
			this.game.state.start('menu');
			//ARRA Main Entrance rv_3 through rv_8
			//this.game.state.start('R6');
		}, this);
		
	}
};

//
// =================================================
/* End of file */
/* Location: ./js/state/story.js */